define(['met', 'mos'], function(met, mos) {
	var _ = {
		Details: null,
		BatchName: null,
		BatchId: null,
		Price: 0
	};
	_.init = function() {
		mui.init({
			swipeBack: true
		});
		_.Price = plus.webview.currentWebview().BatchPrice;

		_.BatchName = plus.webview.currentWebview().BatchName || '';
		_.BatchId = plus.webview.currentWebview().BatchId || 0;
		if(_.BatchId == 0) {
			mui.alert('页面加载出错，请重试', '友情提示', '确定', function(e) {
				mui.back();
			}, 'div')
			return;
		}
		$('.mui-title').html(_.BatchName);
		met.ajax({
			URL: 'AppApi/GetBatchDetail',
			Data: {
				BatchId: _.BatchId
			}
		}, null, function(data) {
			var Details = [],
				data = JSON.parse(data);
			for(var m in data) {
				Details.push({
					Id: data[m].Id,
					ProductId: data[m].ProductId,
					Type: "--",
					Qty: data[m].Qty,
					Price: data[m].ServicePrice,
					Name: data[m].Name
				});
			}
			_.Details = Details;
			_.BatchDetailHtml();
			_.event();
		});
	};
	_.GetProductData = function(List) {
		mos.ProductOperation(List, function(_event) {
			if(_event == 'right') { //更新
				List.Qty = $('#Qty').val();
				List.Price = $('#Price').val();
				List.Profit = $('#Profit').val();
				if(isNaN(Number(List.Price)) || List.Price == "") {
					mui.alert('请检测价格是否输入正确', '提示', '好的', function(e) {
						mui('.mui-btn').button('reset');
					}, 'div')
					return;
				}
				if(List.Type == '轮胎' && (isNaN(Number(List.Profit)) || List.Profit == "")) {
					mui.alert('请检测毛利是否输入正确', '提示', '好的', function(e) {
						mui('.mui-btn').button('reset');
					}, 'div')
					return;
				}
				if(isNaN(Number(List.Qty)) || List.Qty == "") {
					mui.alert('请检测数量是否输入正确', '提示', '好的', function(e) {
						mui('.mui-btn').button('reset');
					}, 'div')
					return;
				}
				_.Details.splice(List.m, 1, List);
			} else { //删除
				_.Details.splice(List.m, 1);
			}
			$('#ProductOperation').remove();
			_.BatchDetailHtml();
		})
	};
	_.BatchDetailHtml = function() {
		var shtml = [];
		shtml.push('<ul class="mic-detail-view">');
		for(var prop in _.Details) {
			shtml.push('<li data-id={4}><div class="mic-detail-left mui-ellipsis-2">项目{0} {1}</div><div class="mic-detail-right"><span>×{2}</span><span>单价：{3}</span></div></li>'.format(Number(prop) + 1, _.Details[prop].Name, _.Details[prop].Qty, _.Details[prop].Price, prop));
		}
		shtml.push('</ul>');
		$('#ProductDetail').html(shtml.join(''));
		mui('.mic-detail-view').off('tap');
		mui('.mic-detail-view').on('tap', 'li', function() {
			var m = this.getAttribute('data-id');
			var List = {
				m: m,
				Id: _.Details[m].Id,
				Name: _.Details[m].Name,
				Price: _.Details[m].Price,
				Profit: "",
				Type: _.Details[m].Type,
				Qty: _.Details[m].Qty,
				Tag: 'Update'
			};
			_.GetProductData(List);
		});
	};
	_.event = function() {
		window.addEventListener('ProductEvent', function(e) {
			//获得事件参数
			var detail = e.detail.Data;
			detail.ProductId = detail.Id;
			_.Details.push(detail);
			_.BatchDetailHtml();
		});
		mui('body').on('tap', '.mic-batch-view li', function() {
			var m = this.getAttribute('data-id');
			met.OpenWindow('c_card_detail.html', null, {
				BatchId: _.Data[m].Id
			});
		});
		//项目服务添加
		mui('body').on('tap', '#ProductAdd', function() {
			_.params = {
				URL: 'AppApi/GetProductList'
			}
			met.ajax(_.params, null, function(data) {
				met.OpenWindow('c_product.html', 'slide-in-bottom', {
					Url: 'c_card_detail.html',
					Data: data
				});
			});
		});
		mui('body').on('tap', '#BtnCardAdd', function() {
			mui.init({
				beforeback: function() {
					var self = plus.webview.currentWebview();
					var Page = plus.webview.getWebviewById('v_order_card.html');
					plus.webview.close('c_card_class.html');
					mui.fire(Page, 'CardDetailsEvent', {
						Price: _.Price,
						BatchId: _.BatchId,
						BatchName: _.BatchName,
						Data: _.Details
					});
					return true;
				}
			});
			mui.back();
		});
	};
	return {
		run: _.init
	};
})