define(['met'], function(met) {
	var _ = {
		Data: null
	};
	_.init = function() {
		mui.init({
			swipeBack: true
		});
		var list = plus.webview.currentWebview().list;
		$('.mui-title').html(list.name);
		var url = list.tag == 'shop' ? 'AppApi/detailshop' : 'AppApi/detail';
		var Data = {
			date: list.date,
			Cat: list.cat,
			Day: list.Day || 'F'
		};
		if(list.DeptId) {
			Data.DeptId = list.DeptId;
		}
		met.ajax({
			URL: url,
			Data: Data
		}, null, function(data) {
			_.Data = data;
			_.OutputHtml();
		});
	};
	_.OutputHtml = function() {
		var html = [],
			d = _.Data;
		for(var i = 0; i < d.length; i++) {
			html.push('<div class="mui-card"><div class="mui-card-header mui-card-media mic-card-header"><div class="mui-media-body">{0}<p>{1}</p></div>'.format(d[i].OrderSourceName, d[i].BillDate));
			
			html.push('</div><div class="mui-card-content">');
			if(d[i].OrderSource != 1) {
				html.push('<div class="mic-card-content-innter">施工状态：{0}</div>'.format(d[i].StatusName));
			}
			if(d[i].CarNo != '' && d[i].CarNo != null && d[i].CarNo.length > 5) {
				html.push('<div class="mic-card-content-innter">车牌号码：{0}</div>'.format(d[i].CarNo));
			}
			if(d[i].IdentityNo != '' && d[i].IdentityNo != null) {
				html.push('<div class="mic-card-content-innter">车架号码：{0}</div>'.format(d[i].IdentityNo));
			}
			if(d[i].Phone != '' && d[i].Phone != null) {
				html.push('<div class="mic-card-content-innter">手机号码：{0}</div>'.format(d[i].Phone));
			}
			if(d[i].IsPaid > 0 && d[i].AccountFee > 0) {
				html.push('<div class="mic-card-content-innter">余额抵扣：{0}</div>'.format(d[i].AccountFee.toFixed(2)));
			}
			if(d[i].IsPaid == 0 && d[i].CouponFee > 0) {
				html.push('<div class="mic-card-content-innter">卡卷抵扣：{0}</div>'.format(d[i].CouponFee.toFixed(2)));
			}
			if(d[i].OrderSource != 1 && d[i].BatchId > 0) {
				html.push('<div class="mic-card-content-innter">套餐抵扣：{0}</div>'.format(d[i].BatchName));
			}
			if(d[i].IsPaid == 0 && d[i].ShouldPay > 0) {
				html.push('<div class="mic-card-content-innter">应付金额：{0}</div>'.format(d[i].ShouldPay.toFixed(2)));
			}
			if(d[i].IsPaid == 0 && d[i].ActPay > 0) {
				html.push('<div class="mic-card-content-innter">支付金额：{0}</div>'.format(d[i].ActPay.toFixed(2)));
			}
			html.push('<div class="mic-card-content-innter">支付状态：{0}</div>'.format(d[i].IsPaid == 1 ? '已支付' : '未支付'));
			html.push('<div class="mic-card-content-innter">钥匙扣：{0}</div>'.format(d[i].NickNo));
			//			
			html.push('<ul class="mic-detail-view mic-card-view"><li class="mic-card-product"><label>服务项目</label>');
		
			html.push('</li>');
			var t = d[i].Details;
			for(var m = 0; m < t.length; m++) {
				html.push('<li><div class="mic-detail-left">项目{0} {1}</div><div class="mic-detail-right"><span>×{2}</span><span>单价：{3}</span></div></li>'.format(Number(m) + 1, t[m].ProductName, t[m].Qty, t[m].ServicePrice.toFixed(2)));
			}
			html.push('</ul></div></div>');
		}
		if(d.length == 0) {
			html.push('<p class="mic-search-alert">没有数据</p>');
		}
		$('.mui-content').html(html.join(''));
	};
	
	return {
		run: _.init
	};
})