define(['met', 'mos'], function(met, mos) {
	var _ = {
		MedelsCheck: false,
		Data: null,
		SubData: null,
		BrandId: 0,
		SerId: 0,
		SpecId: 0,
		BrandName: null,
		SerName: null,
		SpecName: null
	};
	_.init = function() {
		mui.init({
			swipeBack: true,
			beforeback: _.back
		});

		_.MedelsCheck = plus.webview.currentWebview().MedelsCheck || false;
		_.params = {
			URL: 'AppApi/GetCarBrand'
		}
		met.ajax(_.params, null, function(data) {
			_.Data = data;
			_.html();
		});
	};
	_.html = function() {
		var hHtml = [],
			cHtml = [],
			t = true,
			h = _.Data.HotList,
			c = _.Data.ColdList;
		for(var m in h) {
			hHtml.push('<li class="mui-table-view-cell mui-media mui-col-xs-0 mui-col-sm-0" data-id={0} data-name="{2}"><img src="..{1}" /><div class="mui-media-body">{2}</div></li>'.format(h[m].Id, h[m].Pic, h[m].ZhName));
		}
		$('#HotData').html(hHtml.join(''));
		for(var n = 0; n < c.length; n++) {
			if(n == 0 || c[n].PinYin != c[n - 1].PinYin) {
				cHtml.push('<li data-group="{0}" class="mui-table-view-divider mui-indexed-list-group">{0}</li>'.format(c[n].PinYin.toUpperCase()));
			}
			cHtml.push('<li class="mui-table-view-cell mui-indexed-list-item" data-id="{0}" data-name="{2}"><img src="..{1}" /><span>{2}</span></li>'.format(c[n].Id, c[n].Pic, c[n].ZhName));
		}
		$('#ColdData').html(cHtml.join(''));
		//侧滑容器父节点 点击事件
		mui('#offCanvasContentScroll').on('tap', '.mui-table-view-cell', function() {
			_.BrandId = this.getAttribute('data-id');
			_.BrandName = this.getAttribute('data-name');
			_.SerId = 0;
			_.SpecId = 0;
			_.SerName = null;
			_.SpecName = null;
			if(!_.MedelsCheck) {
				_.BeforeBack();
				return;
			}
			met.ajax({
				URL: 'AppApi/GetCarModel',
				Data: {
					Id: _.BrandId
				}
			}, null, function(data) {
				if(data.length == 0) {
					_.BeforeBack();
					return;
				}
				_.SubData = data;
				_.OpenMenu();
			});
		});
	};

	var menu = mui.preload({
			id: _.BrandId,
			url: 'c_models_menu.html',
			styles: {
				left: "30%",
				width: '70%',
				zindex: 9997
			},
			extras: {
				Data: []
			}
		}),
		showMenu = false,
		mask = mui.createMask(function() {
			_._closeMenu()
		});

	_.back = function() {
		if(showMenu) {
			//菜单处于显示状态，返回键应该先关闭菜单,阻止主窗口执行mui.back逻辑；
			_.CloseMenu();
			return false;
		} else {
			//菜单处于隐藏状态，执行返回时，要先close菜单页面，然后继续执行mui.back逻辑关闭主窗口；
			menu.close('none');
			return true;
		}
	};

	/*
	 * 显示菜单菜单
	 */
	_.OpenMenu = function() {
		if(!showMenu) {
			menu = mui.preload({
				id: _.BrandId,
				url: 'c_models_menu.html',
				styles: {
					left: "30%",
					width: '70%',
					zindex: 9997
				},
				extras: {
					Data: _.SubData
				}
			});
			//解决android 4.4以下版本webview移动时，导致fixed定位元素错乱的bug;
			if(mui.os.android && parseFloat(mui.os.version) < 4.4) {
				document.querySelector("header.mui-bar").style.position = "static";
				//同时需要修改以下.mui-contnt的padding-top，否则会多出空白；
				document.querySelector(".mui-bar-nav~.mui-content").style.paddingTop = "0px";
			}
			mui.later(function() {
				//侧滑菜单处于隐藏状态，则立即显示出来；
				//显示完毕后，根据不同动画效果移动窗体；
				menu.show('none', 0, function() {
					menu.setStyle({
						left: '30%',
						transition: {
							duration: 150
						}
					});
				});
				//显示主窗体遮罩
				mask.show();
				showMenu = true;
			}, 300);
		}
	};

	_.CloseMenu = function() {
		//窗体移动
		_._closeMenu();
		//关闭遮罩
		mask.close();
	};

	/**
	 * 关闭侧滑菜单(业务部分)
	 */
	_._closeMenu = function() {
		if(showMenu) {
			//解决android 4.4以下版本webview移动时，导致fixed定位元素错乱的bug;
			if(mui.os.android && parseFloat(mui.os.version) < 4.4) {
				document.querySelector("header.mui-bar").style.position = "fixed";
				//同时需要修改以下.mui-contnt的padding-top，否则会多出空白；
				document.querySelector(".mui-bar-nav~.mui-content").style.paddingTop = "44px";
			}
			//主窗体开始侧滑；
			menu.setStyle({
				left: '100%',
				transition: {
					duration: 150
				}
			});
			//等窗体动画结束后，隐藏菜单webview，节省资源；
			setTimeout(function() {
				menu.hide();
			}, 300);
			showMenu = false;
		}
	};
	//menu页面向右滑动，关闭菜单；
	window.addEventListener("menu:swiperight", function(e) {
		_.CloseMenu();
		var d = e.detail;
		_.SerId = d.SerId;
		_.SpecId = d.SpecId;
		_.SerName = d.SerName;
		_.SpecName = d.SpecName;
		_.BeforeBack();
	});

	mui.menu = function() {
		if(showMenu) {
			_.CloseMenu();
		}
	};

	_.BeforeBack = function() {
		mui.init({
			beforeback: function() {
				var self = plus.webview.currentWebview();
				var Page = plus.webview.getWebviewById(self.Url);
				mui.fire(Page, 'CarBrandEvent', {
					BrandId: _.BrandId,
					SerId: _.SerId,
					SpecId: _.SpecId,
					BrandName: _.BrandName,
					SerName: _.SerName,
					SpecName: _.SpecName
				});
				return true;

			}
		});
		mui.back();
	};
	return {
		run: _.init
	};
})