define(['met', 'mos'], function(met, mos) {
	var _ = {
		Date: null,
		ShopName: null,
		Data: null
	};
	_.init = function() {
		mui.init({
			swipeBack: true
		});
		_.Date = plus.webview.currentWebview().date;
		_.ShopName=plus.webview.currentWebview().ShopName;
		_.DeptId=plus.webview.currentWebview().DeptId;
		//日期
		var DHtml = [];
		for(var i = 0; i < 12; i++) {
			var DateTime = moment().add(-i, 'Month');
			DHtml.push('<li class="mui-table-view-cell" data-id="{0}"><a href="#topDate">{1}</span></a></li>'.format(DateTime.format('YYYY-MM-DD'), DateTime.format('YYYY年MM月')));
		}
		$('#topDate .mui-table-view').html(DHtml.join(''));
		mui('#topDate .mui-scroll-wrapper').scroll({
			indicators: false //是否显示滚动条
		});
		_.GetData();
		_.event();
	};
	_.GetData = function() {
		met.ajax({
			URL: 'AppApi/EmployeeAch',
			Data: {
				DeptId: _.DeptId, date: _.Date
			}
		}, null, function(data) {
			$('.mui-title').html(moment(_.Date).format('YYYY年MM月'));
			_.Data = data;
			_.AchCategory();
		});
	};
	_.AchCategory = function() {
		var html = [],
			d = _.Data;
		html.push('<li class="mui-table-view-cell">{0}个人销售额明细</li>'.format(_.ShopName));
		for(var i = 0; i < d.length; i++) {
			html.push('<li class="mui-table-view-cell category" data-m="{2}"><a class="mui-navigate-right">{0}<span>(￥{1})</span></a></li>'.format(d[i].FollowEmployeeName,d[i].All.toFixed(2),i));
		}
		$('#EmpCategory').html(html.join(''));
		mui('#EmpCategory').off('tap');
		mui('#EmpCategory').on('tap', '.category', function() {
			var m=this.getAttribute('data-m');
			var data=mos.AchPieData(_.Data[m]);
			_.Pie2D(data);
		});
	};
	_.Pie2D = function(data) {
		var $AchPie = $(".mic-ach-pie");
		var width = $(document).width()*0.9;
		var height = $AchPie.height() - 1;
		new iChart.Pie2D({
			render: 'AchPie',
			data: data,
			legend: {
				enable: false
			},
			sub_option: {
				label: {
					background_color: null,
					sign: false, //设置禁用label的小图标
					padding: '-2 0',
					border: {
						enable: false,
						color: '#666666'
					},
					fontsize: 13,
					fontweight: 100,
					color: '#333333'
				}
			},
			offsety: 0, //设置向x轴负方向偏移位置60px
			showpercent: false,
			decimalsnum: 2,
			width: width,
			height: height
		}).draw();
		$('#EmpPie').show();
		mui('#EmpPie').off('tap');
		mui('#EmpPie').on('tap','a',function(){
		  $('#EmpPie').hide();
		}) 
	};
	_.event = function() {
		//日期选择
		mui('#topDate').on('tap', '.mui-table-view li', function() {
			_.Date = this.getAttribute('data-id');
			_.GetData();
		});
	};
	return {
		run: _.init
	};
})