define(['met', 'mos'], function(met, mos) {
	var _ = {
		Date: null,
		Data: null,
		DayData: null
	};
	_.init = function() {
		mui.init({
			swipeBack: true
		});
		//日期
		var DHtml = [];
		for(var i = 0; i < 12; i++) {
			var DateTime = moment().add(-i, 'Month');
			DHtml.push('<li class="mui-table-view-cell" data-id="{0}"><a href="#topDate">{1}</span></a></li>'.format(DateTime.format('YYYY-MM-DD'), DateTime.format('YYYY年MM月')));
		}
		$('#topDate .mui-table-view').html(DHtml.join(''));
		mui('#topDate .mui-scroll-wrapper').scroll({
			indicators: false //是否显示滚动条
		});
		_.Date = new Date();
		$('.mic-view-ach label').html(moment(_.Date).format('YYYY年MM月'));
		_.GetData();
		_.event();
	};
	_.GetData = function() {
		met.ajax({
			URL: 'AppApi/achievementshop',
			Data: {
				date: _.Date
			}
		}, null, function(data) {
			var MonthAch = data.MonthAch;
			var LastDaysAch = data.LastDaysAch;
			$('.mic-view-ach label').html(moment(_.Date).format('YYYY年MM月'));
			$('.mic-ach-amount').html(MonthAch.All.toFixed(2));
			_.Data = mos.AchPieData(MonthAch);
			var dayData = [];
			for(var prop in LastDaysAch) {
				var name = prop == 0 ? "当天" : prop == 1 ? "昨天" : prop == 2 ? "前天" : Number(moment().add(-prop, 'day').format("DD"));
				dayData.push({
					name: name,
					value: LastDaysAch[prop].All,
					color: '#ff7943'
				});
				if(Number(moment().add(-prop, 'day').format("DD")) == 1) break;
			}
			_.DayData = dayData;
			_.Pie2D();
			_.Column2D();
			_.AchCategory();
		});
	};
	_.AchCategory = function() {
		var html = [],
			d = _.Data;
		html.push('<li class="mui-table-view-cell">类目明细</li>');
		for(var i = 0; i < d.length; i++) {
			html.push('<li class="mui-table-view-cell category" data-list=' + "'" + JSON.stringify(d[i]) + "'" + '><a class="mui-navigate-right">{0}</a></li>'.format(d[i].name));
		}
		$('#Category').html(html.join(''));
		mui('#Category').off('tap');
		mui('#Category').on('tap', '.category', function() {
			var list = JSON.parse(this.getAttribute('data-list'));
			list.date = _.Date;
			list.tag = 'ach';
			met.OpenWindow('c_category_details.html', null, {
				list: list
			});
		});
	};
	_.Pie2D = function() {
		var $AchPie = $(".mic-ach-pie");
		var width = $AchPie.width()-2;
		var height = $AchPie.height()-2;
		var d=new iChart.Pie2D({
			render: 'AchPie',
			data: _.Data,
			legend: {
				enable: false
			},
			sub_option: {
				label: {
					background_color: null,
					sign: false, //设置禁用label的小图标
					padding: '-2 0',
					border: {
						enable: false,
						color: '#666666'
					},
					fontsize: 13,
					fontweight: 100,
					color: '#333333'
				}
			},
			offsety: 0, //设置向x轴负方向偏移位置60px
			showpercent: false,
			decimalsnum: 2,
			width: width,
			height: height
		});
		d.draw();
		d.eventOff();
	};
	_.Column2D = function() {
		var data = _.DayData;

		var $AchColumn = $(".mic-ach-column");
		var width = $AchColumn.width();
		var height = $AchColumn.height();
		var d = new iChart.Column2D({
			render: 'AchColumn',
			data: data,
			title: {
				text: '店铺近7日销售业绩',
				color: '#333333',
				fontsize: 16,
				fontweight: 100
			},
			offsetx: 20, //设置向x轴负方向偏移位置60px
			showpercent: false,
			decimalsnum: 2,
			width: width,
			height: height,
			coordinate: {
				background_color: '#ffffff',
				scale: [{
					position: 'left',
					// start_scale: 0,
					// end_scale: 0,
					// scale_space: 2000,
					scale_enable: false,
					listeners: {
						parseText: function(t, x, y) {
							t = t == 0 ? 0 : t >= 1000 ? t / 10000 + '万' : t;
							return {
								text: t
							}
						}
					}
				}]
			}
		});
		d.draw();
		d.eventOff();
	};
	_.event = function() {
		mui.init({
			swipeBack: true
		});
		//日期选择
		mui('#topDate').on('tap', '.mui-table-view li', function() {
			_.Date = this.getAttribute('data-id');
			_.GetData();
		});
		mui('body').on('tap', '#AchEmpSale li', function() {
			met.OpenWindow('ach_emp.html', null, {
				date: _.Date,
				DeptId: "27",
				ShopName: "店铺"
			});
		})
	};
	return {
		run: _.init
	};
})