define(['met', 'mos'], function(met, mos) {
	var _ = {
		Date: null,
		MonthlyValue: null,
		MonthlyText: null,
		GroupDepData: null,
		ShopData: null,
		MonthlyText: null,
	};
	_.init = function() {
		mui.init({
			swipeBack: true
		});
		//日期
		var DHtml = [];
		for(var i = 0; i < 12; i++) {
			var DateTime = moment().add(-i, 'Month');
			DHtml.push('<li class="mui-table-view-cell" data-id="{0}"><a href="#topDate">{1}</span></a></li>'.format(DateTime.format('YYYY-MM-DD'), DateTime.format('YYYY年MM月')));
		}
		$('#topDate .mui-table-view').html(DHtml.join(''));
		mui('#topDate .mui-scroll-wrapper').scroll({
			indicators: false //是否显示滚动条
		});
		_.Date = new Date();
		$('.mic-view-ach label').html(moment(_.Date).format('YYYY年MM月'));
		_.GetData();
		_.event();
	};
	_.GetData = function() {
		met.ajax({
			URL: 'AppApi/AchievementTotal',
			Data: {
				date: _.Date
			}
		}, null, function(data) {
			if (data.Monthly.Code == 0) {
				mui.alert(data.Monthly.Msg,'温馨提示','确定',function (e) {
				   e.index
				},'div');
                return;
            }
            if (data.GroupDep.Code == 0) {
				mui.alert(data.GroupDep.Msg,'温馨提示','确定',function (e) {
				   e.index
				},'div');
                return;
            }
			var Monthly = data.Monthly.Data.LastDaysAch;
			var MonthlyValue = [], MonthlyText = [];
            for (var m in Monthly) {
                var name = m == 0 ? "当天" : m == 1 ? "昨天" : m == 2 ? "前天" : Number(moment().add(-m, 'day').format("DD")).toString() + "日";
                MonthlyValue.unshift(Monthly[m].All);
                MonthlyText.unshift(name);
                if(Number(moment().add(-m, 'day').format("DD"))==1) break;
            }
            _.MonthlyValue = MonthlyValue;
            _.MonthlyText = MonthlyText;
            //--
            var GroupDep=data.GroupDep.Data;
            var Total = 0, GroupDepData = [], ShopData = [];
            for (var n in GroupDep) {
                var DeptId = GroupDep[n].DeptId;
                GroupDepData.push({
                    name: DeptId == 9 ? '黄边' : DeptId == 12 ? '番禺' : DeptId == 32 ? '石龙' : DeptId == 38 ? '电商' : DeptId == 37 ? '金沙洲' : GroupDep[n].DeptName,
                    value: GroupDep[n].ActPayTotal,
                    color: '#ff7943',
                    DeptId: DeptId,
                    date: _.Date
                });
                ShopData.push({DeptName: GroupDep[n].DeptName, DeptId: GroupDep[n].DeptId});
                Total = Total + Number(GroupDep[n].ActPayTotal);
            }
            _.GroupDepData = GroupDepData;
            _.ShopData = ShopData;
            
			$('.mic-view-ach label').html(moment(_.Date).format('YYYY年MM月'));
			$('.mic-ach-amount').html(Total.toFixed(2));
			
			_.Line2D();
			_.Column2D();
			_.ShopCategory();
		});
	};
	_.ShopCategory = function() {
		var html = [],
			d = _.ShopData;
		html.push('<li class="mui-table-view-cell">所有门店</li>');
		for(var i = 0; i < d.length; i++) {
			html.push('<li class="mui-table-view-cell category" data-list=' + "'" + JSON.stringify(d[i]) + "'" + '><a class="mui-navigate-right">{0}</a></li>'.format(d[i].DeptName));
		}
		$('#CategoryShop').html(html.join(''));
		mui('#CategoryShop').off('tap');
		mui('#CategoryShop').on('tap', '.category', function() {
			var list = JSON.parse(this.getAttribute('data-list'));
			list.date = _.Date;
			met.OpenWindow('ach_total_info.html', null, {
				list: list
			});
		});
	};
	_.Line2D = function() {
		var data = [{value: _.MonthlyValue, color: '#ff7943', line_width: 1}];
        var $Ach = $(".mic-ach-line");
        var width = $Ach.width();
        var height = $Ach.height();
        var d = new iChart.LineBasic2D({
            render: 'AchLine',
            data: data,
            title: {
                text: '日销售情况',
                color: '#333333',
                fontsize: 16,
                fontweight: 100
            },
            width: width,
            height: height,
            offsety: -5,
            offsetx: 5,
            coordinate: {
                height: '80%',
                width: '85%',
                background_color: '#ffffff',
                scale: [{
                    position: 'left',
                    scale_enable: false,//禁用小横线
                    label: {color: '#333333', fontsize: 11},
                    listeners: {
                        parseText: function (t, x, y) {
                            t = t == 0 ? '' : t >= 10000 ? t / 10000 + '万' : t >= 1000 ? t / 1000 + '千' : t;
                            return {text: t}
                        }
                    }
                }, {
                    position: 'bottom',
                    scale_enable: false,
                    start_scale: 1,
                    end_scale: 10,
                    label: {color: '#333333', fontsize: 11},
                    labels: _.MonthlyText
                }]
            },
            sub_option: {
                hollow_inside: true,//设置一个点的亮色在外环的效果
                point_size: 6
            }
        });
        d.draw();
        d.eventOff();
	};
	_.Column2D = function() {
		var $AchColumn = $(".mic-ach-column");
		var width = $AchColumn.width();
		var height = $AchColumn.height();
		var d = new iChart.Column2D({
            render: 'AchColumn',
            data: _.GroupDepData,
            showpercent: false,
            decimalsnum: 2,
            width: width,
            height: height,
            offsetx: 5,
            coordinate: {
                scale: [{
                    position: 'left',
                    scale_size: 0,
                    listeners: {
                        parseText: function (t, x, y) {
                            t = t == 0 ? 0 : t >= 10000 ? t / 10000 + '万' : t >= 1000 ? t / 1000 + '千' : t;
                            return {text: t}
                        }
                    }
                }]
            }
        });
		d.draw();
		d.eventOff();
	};
	_.event = function() {
		//日期选择
		mui('#topDate').on('tap', '.mui-table-view li', function() {
			_.Date = this.getAttribute('data-id');
			_.GetData();
		});
	};
	return {
		run: _.init
	};
})