define(['met', 'mos'], function(met, mos) {
	var _ = {
		list: null,
		Day: "F",
		Date: null,
		Data: null,
		RDay: null
	};
	_.init = function() {
		mui.init({
			swipeBack: true
		});
		_.list = plus.webview.currentWebview().list;

		//日期
		var DHtml = [];
		for(var i = 0; i < 12; i++) {
			var DateTime = moment().add(-i, 'Month');
			DHtml.push('<li class="mui-table-view-cell" data-id="{0}"><a href="#topDate">{1}</span></a></li>'.format(DateTime.format('YYYY-MM-DD'), DateTime.format('YYYY年MM月')));
		}
		$('#topDate .mui-table-view').html(DHtml.join(''));
		mui('#topDate .mui-scroll-wrapper').scroll({
			indicators: false //是否显示滚动条
		});

		_.Date = _.list.date;
		$('.mic-view-ach label').html(moment(_.Date).format('YYYY年MM月'));
		$('#RDayData label').html(Number(moment(_.Date).format('MM')));
		$('.mui-title').html(_.list.DeptName + '业绩')
		$('#DeptName').html(_.list.DeptName + '销售额');
		$('#AchEmpSale a').html(_.list.DeptName + '个人销售额');
		_.GetData();
		_.event();
	};
	_.GetData = function() {
		met.ajax({
			URL: 'AppApi/achievementshop',
			Data: {
				DeptId: _.list.DeptId,
				Day: _.Day,
				date: _.Date
			}
		}, null, function(data) {
			var MonthAch = data.MonthAch;
			var LastDaysAch = data.LastDaysAch;
			$('.mic-view-ach label').html(moment(_.Date).format('YYYY年MM月'));
			$('#RDayData label').html(Number(moment(_.Date).format('MM')));
			$('.mic-ach-amount').html(MonthAch.All.toFixed(2));
			_.Data = mos.AchPieData(MonthAch);

			_.Pie2D();
			_.AchCategory();
			_.RData();
		});
	};
	_.RData = function() {
		var MaxDay = Number(moment(_.Date).endOf('month').format('DD'));
		var RDay = [];
		for(var i = 0; i < MaxDay; i++) {
			RDay.push({
				value: (i + 1) < 10 ? '0' + (i + 1) : i + 1,
				text: i + 1
			})
		}
		_.RDay = RDay;
		var userPicker = new mui.PopPicker();
		userPicker.setData(_.RDay);
		mui('#RDayData').off('tap');
		mui('#RDayData').on('tap', 'li', function() {
			userPicker.show(function(items) {
				var date = moment(_.Date).format('YYYY-MM') + '-' + items[0].value;
				_.Date = date;
				_.Day = 'T';
				_.GetData();
			});
		});
	};
	_.AchCategory = function() {
		var html = [],
			d = _.Data;
		html.push('<li class="mui-table-view-cell">类目明细</li>');
		for(var i = 0; i < d.length; i++) {
			html.push('<li class="mui-table-view-cell category" data-list=' + "'" + JSON.stringify(d[i]) + "'" + '><a class="mui-navigate-right">{0}</a></li>'.format(d[i].name));
		}
		$('#Category').html(html.join(''));
		mui('#Category').off('tap');
		mui('#Category').on('tap', '.category', function() {
			var list = JSON.parse(this.getAttribute('data-list'));
			list.date = _.Date;
			list.DeptId = _.list.DeptId;
			list.Day = _.Day;
			list.tag = 'shop';
			met.OpenWindow('c_category_details.html', null, {
				list: list
			});
		});
	};
	_.Pie2D = function() {
		var $AchPie = $(".mic-ach-pie");
		var width = $AchPie.width() - 2;
		var height = $AchPie.height() - 2;
		var d = new iChart.Pie2D({
			render: 'AchPie',
			data: _.Data,
			legend: {
				enable: false
			},
			sub_option: {
				label: {
					background_color: null,
					sign: false, //设置禁用label的小图标
					padding: '-2 0',
					border: {
						enable: false,
						color: '#666666'
					},
					fontsize: 13,
					fontweight: 100,
					color: '#333333'
				}
			},
			offsety: 0, //设置向x轴负方向偏移位置60px
			showpercent: false,
			decimalsnum: 2,
			width: width,
			height: height
		});
		d.draw();
		d.eventOff();
	};
	_.event = function() {
		//日期选择
		mui('#topDate').on('tap', '.mui-table-view li', function() {
			_.Date = this.getAttribute('data-id');
			_.Day = "F";
			_.GetData();
		});
		mui('body').on('tap', '#AchEmpSale li', function() {
			met.OpenWindow('ach_emp.html', null, {
				date: _.Date,
				DeptId: _.list.DeptId,
				ShopName: _.list.DeptName
			});
		})
	};
	return {
		run: _.init
	};
})