define(['met', 'mos'], function(met, mos) {
	var _ = {
		Date: null,
		Data: null
	};
	_.init = function() {
		mui.init({
			pullRefresh: {
				container: '#pullrefresh',
				down: {
					callback: function() {
						_.GetData(true);
					}
				}
			}
		});
		//日期
		var DHtml = [];
		for(var i = 0; i < 12; i++) {
			var DateTime = moment().add(-i, 'Month');
			DHtml.push('<li class="mui-table-view-cell" data-id="{0}"><a href="#topDate">{1}</span></a></li>'.format(DateTime.format('YYYY-MM-DD'), DateTime.format('YYYY年MM月')));
		}
		$('#topDate .mui-table-view').html(DHtml.join(''));
		mui('#topDate .mui-scroll-wrapper').scroll({
			indicators: false //是否显示滚动条
		});
		_.Date = new Date();
		_.GetData();
		_.event();
	};
	_.GetData = function(pull) {
		met.ajax({
			URL: 'AppApi/achievement',
			Data: {
				date: _.Date
			}
		}, pull, function(data) {
			if(pull) mui('#pullrefresh').pullRefresh().endPulldownToRefresh();
			$('.mic-view-ach label').html(moment(_.Date).format('YYYY年MM月'));
			$('.mic-ach-amount').html(data.All.toFixed(2));
			_.Data = mos.AchPieData(data);
			_.Pie2D();
			_.AchCategory();
		});
	};
	_.AchCategory = function() {
		var html = [],
			d = _.Data;
		html.push('<li class="mui-table-view-cell">类目明细</li>');
		for(var i = 0; i < d.length; i++) {
			html.push('<li class="mui-table-view-cell category" data-list=' + "'" + JSON.stringify(d[i]) + "'" + '><a class="mui-navigate-right">{0}</a></li>'.format(d[i].name));
		}
		$('#Category').html(html.join(''));
		mui('#Category').off('tap');
		mui('#Category').on('tap', '.category', function() {
			var list=JSON.parse(this.getAttribute('data-list'));
			list.date=_.Date;
			list.tag='shop';
			met.OpenWindow('c_category_details.html', null, {
				list: list
			});
		});
	};
	_.Pie2D = function() {
		var $AchPie = $(".mic-ach-pie");
		var width = $AchPie.width()-2;
		var height = $AchPie.height()-2;
		var d=new iChart.Pie2D({
			render: 'AchPie',
			data: _.Data,
			legend: {
				enable: false
			},
			sub_option: {
				label: {
					background_color: null,
					sign: false, //设置禁用label的小图标
					padding: '-2 0',
					border: {
						enable: false,
						color: '#666666'
					},
					fontsize: 13,
					fontweight: 100,
					color: '#333333'
				}
			},
			offsety: 0, //设置向x轴负方向偏移位置60px
			showpercent: false,
			decimalsnum: 2,
			width: width,
			height: height
		});
		d.draw();
		d.eventOff();
	};
	_.event = function() {
		//日期选择
		mui('#topDate').on('tap', '.mui-table-view li', function() {
			_.Date = this.getAttribute('data-id');
			_.GetData();
		});
	};
	return {
		run: _.init
	};
})