define(['met'], function(met) {
	var _ = {
		ShopList: null,
		DeptId: null
	};
	_.init = function() {
		mui.init({
			swipeBack: true
		});
		$('#Date').val(moment(new Date()).format("YYYY-MM-DD"));
		met.ajax({
			URL: 'AppApi/GetRoleShopList'
		}, null, function(data) {
			var ShopList = [];
			for(var m in data) {
				ShopList.push({
					value: data[m].Id,
					text: data[m].Name
				})
			}
			_.ShopList = ShopList;

			met.ajax({
				URL: 'AppApi/AdjustList'
			}, null, function(data) {
				var d = data,
					html = [];
				for(var i = 0; i < d.length; i++) {
					html.push('<li class="mui-table-view-cell" data-adjustno="{0}"><a class="mui-navigate-right"><div class="mui-media-body">单号：{0}'.format(d[i].AdjustNo));
					if(d[i].StatusName != '初始') {
						html.push('<span><已提交></已提交></span>');
					}
					html.push('<div class="mui-ellipsis">日期：{0}</div><div class="mui-ellipsis">创建人：{1}</div></div></a></li>'.format(d[i].Date, d[i].MuName));
				}
				$('.mic-view-inventory').html(html.join(''));
				_.event();
			});
		});
	};
	_.event = function() {
		window.addEventListener('RefreshEvent', function(e) {
			//获得事件参数
			location.reload();
		});
		
		var userPicker = new mui.PopPicker();
		userPicker.setData(_.ShopList);
		mui('body').on('tap', '#ShopName', function() {
			userPicker.show(function(items) {
				_.DeptId = items[0].value;
				$('#ShopName').val(items[0].text);
			});
		});
		//创建盘点
		mui('body').on('tap', '#CreateAdjust', function() {
			var date = $('#Date').val() == "" ? new Date() : $('#Date').val();
			if(_.DeptId == null) {
				mui.alert('请选择盘点门店', '温馨提示', '确定', function(e) {
					e.index
				}, 'div')
				return;
			}
			met.ajax({
				URL: 'AppApi/CreateAdjust',
				Data: {
					Date: date,
					DeptId: _.DeptId
				}
			},null, function(data) {
				var AdjustNo = data.AdjustNo;
				met.OpenWindow('v_inventory_adjust.html', null, {
					AdjustNo: AdjustNo
				})
			})
		});
		//盘点列表事件
		mui('.mic-view-inventory').on('tap', 'li', function() {
			var AdjustNo = this.getAttribute('data-adjustno');
			met.OpenWindow('v_inventory_adjust.html', null, {
				AdjustNo: AdjustNo
			})
		})
	};
	return {
		run: _.init
	};
})