define(['met', 'mos'], function(met, mos) {
	var _ = {
		AdjustNo: null,
		Data: null,
		ProductList: null,
		I: null
	};
	_.init = function() {
		mui.init({
			swipeBack: true
		});
		_.AdjustNo = plus.webview.currentWebview().AdjustNo;
		met.ajax({
			URL: 'AppApi/GetAdjustEntity',
			Data: {
				AdjustNo: _.AdjustNo
			}
		}, null, function(data) {
			$('.AdjustNo').html(data.AdjustNo);
			$('.Date').html(data.Date);
			$('.MuName').html(data.MuName);
			_.Data = data.Details;
			_.AjustHtml(data.StatusName);
			_.event();
		});
		met.ajax({
			URL: 'AppApi/ProductStorage'
		}, null, function(data) {
			_.ProductList = data;
		});
	};
	_.AjustHtml = function(StatusName) {
		var html = [],
			d = _.Data;
		if(StatusName == '初始') {
			$('.mic-row').show();
			$('nav').show();
		} else {
			$('.mic-row').hide();
			$('nav').hide();
		}
		if(StatusName == '初始') {
			html.push('<li class="mui-table-view-cell">盘点列表</li>')
			for(var i = 0; i < d.length; i++) {
				html.push('<li class="mui-table-view-cell adjust" data-m="{1}"><a class="mui-navigate-right"><div class="mui-media-body"><div class="mui-ellipsis">{0}</div>'.format(d[i].ProductName, i));
				html.push('<div class="mui-ellipsis">{0}</div>'.format(d[i].Barcode));
				html.push('</div><span class="mui-badge mui-badge-primary">×{0}</span></a></li>'.format(d[i].AdjustQty));
			}
		} else {
			html.push('<li class="mui-table-view-cell">盘点列表(盘点已提交)</li>')
			for(var i = 0; i < d.length; i++) {
				html.push('<li class="mui-table-view-cell"><div class="mui-media-body"><div class="mui-ellipsis">{0}</div>'.format(d[i].ProductName));
				html.push('<div class="mui-ellipsis">{0}<span>(库存/盘点 {1}/{2})</span></div></div>'.format(d[i].Barcode, d[i].StockQty, d[i].AdjustQty));
				var N = Number(d[i].AdjustQty) - Number(d[i].StockQty)
				if(N > 0) {
					html.push('<span class="mui-badge mui-badge-purple">+{0}</span>'.format(N));
				} else if(N < 0) {
					html.push('<span class="mui-badge mui-badge-danger">-{0}</span>'.format(N));
				} else {
					html.push('<span class="mui-badge mui-badge-primary">正常</span>');
				}
				html.push('</li>');
			}
		}
		$('.mic-view-ajust').html(html.join(''));
		mui('.mic-view-ajust').off('tap');
		if(StatusName == '初始') {
			mui('.mic-view-ajust').off('tap');
			mui('.mic-view-ajust').on('tap', '.adjust', function() {
				var m = this.getAttribute('data-m');
				var List = {
					m: m,
					Id: d[m].ProductId,
					Name: d[m].ProductName,
					Qty: d[m].AdjustQty,
					Barcode: d[m].Barcode,
					Tag: 'Update'
				};
				_.AdjustOpeEvent(List);
			});
		}
	};
	_.AdjustOpeEvent = function(List) {
		mos.ProductScanOperation(List, function(_event) {
			if(_event == 'right') { //更新
				List.Qty = $('#Qty').val();
				if(isNaN(Number(List.Qty)) || List.Qty == "") {
					mui.alert('请检测数量是否输入正确', '提示', '好的', function(e) {
						mui('.mui-btn').button('reset');
					}, 'div')
					return;
				}
				var list = {
					AdjustNo: _.AdjustNo,
					m: List.m,
					ProductId: List.Id,
					ProductName: List.Name,
					Barcode: List.Barcode,
					AdjustQty: List.Qty
				};
				_.AddAdjust(list, 'Update');
			} else { //删除
				var list = {
					AdjustNo: _.AdjustNo,
					m: List.m,
					ProductId: List.Id,
					ProductName: List.Name,
					Barcode: List.Barcode,
					AdjustQty: List.Qty
				};
				_.DeleteAdjust(list);
			}

			$('#ProductOperation').remove();
		});
	};
	_.AddAdjust = function(list, tag) {
		met.ajax({
			URL: 'AppApi/AddAdjustDetail',
			Data: list
		}, null, function(data) {
			if(tag == 'Update') {
				_.Data.splice(list.m, 1, list);
			} else {
				_.Data.push(list);
			}
			_.AjustHtml('初始');
		});
	};
	_.DeleteAdjust = function(list) {
		met.ajax({
			URL: 'AppApi/RemoveAdjustDetail',
			Data: list
		}, null, function(data) {
			_.Data.splice(list.m, 1);
			_.AjustHtml('初始');
		});
	};
	_.event = function() {
		window.addEventListener('BarcodeScanEvent', function(e) {
			//获得事件参数
			var Barcode = e.detail.result;
			var tag = true;
			for(var i = 0; i < _.Data.length; i++) {
				if(_.Data[i].Barcode == Barcode) {
					var list = {
						m: i,
						Id: _.Data[i].ProductId,
						Name: _.Data[i].ProductName,
						Qty: _.Data[i].AdjustQty,
						Barcode: Barcode,
						Tag: 'Update'
					};
					_.AdjustOpeEvent(list);
					tag = false;
				}
			}
			if(tag) {
				for(var prop in _.ProductList) {
					var List = _.ProductList[prop];
					for(var p in List) {
						if(List[p].Barcode == Barcode) {
							tag = false;
							var list = {
								Id: List[p].Id,
								Name: List[p].Name,
								Qty: "",
								Barcode: Barcode,
								Tag: 'Select'
							};
							_.AdjustOpeEvent(list);
						}
					}
				}
			}
			if(tag) {
				mui.alert('找不到此条形码，请手动选择产品盘点', '温馨提示', '确定', function(e) {
					e.index
				}, 'div')
			}
		});
		window.addEventListener('ProductEvent', function(e) {
			//获得事件参数
			var Data = e.detail.Data;
			var list = {
				AdjustNo: _.AdjustNo,
				ProductId: Data.Id,
				ProductName: Data.Name,
				Barcode: Data.Barcode,
				AdjustQty: Data.Qty
			};
			_.AddAdjust(list, "Select");
		});
		//手动添加
		mui('body').on('tap', '#HandAdd', function() {
			met.OpenWindow('c_product.html', 'slide-in-bottom', {
				Url: 'v_inventory_adjust.html',
				Id: 'Scan',
				Data: _.ProductList
			});
		});
		//扫码添加
		mui('body').on('tap', '#ScanAdd', function() {
			met.OpenWindow('barcode_scan.html', null, {
				Url: 'v_inventory_adjust.html'
			});
		});
		//取消盘点
		mui('body').on('tap', '#BtnCancel', function() {
			mui.confirm('是否确认取消此盘点', '温馨提示', ['否', '是'], function(e) {
				if(e.index == 1) {
					met.ajax({
						URL: 'AppApi/AdjustCancel',
						Data: {
							AdjustNo: _.AdjustNo
						}
					}, null, function(data) {
						mui.alert('取消成功', '温馨提示', '确定', function(e) {
							mui.init({
								beforeback: function() {
									var Page = plus.webview.getWebviewById('v_inventory.html');
									mui.fire(Page, 'RefreshEvent');
									return true;
								}
							});
							mui.back();
						}, 'div')
					})
				}
			}, 'div')
		});
		//提交盘点
		mui('body').on('tap', '#BtnSubmit', function() {
			mui.confirm('是否确认提交此盘点', '温馨提示', ['否', '是'], function(e) {
				if(e.index == 1) {
					alert(_.AdjustNo)
					met.ajax({
						URL: 'AppApi/SubmitAdjsut',
						Data: {
							AdjustNo: _.AdjustNo
						}
					}, null, function(data) {
						mui.alert('提交成功', '温馨提示', '确定', function(e) {
							mui.init({
								beforeback: function() {
									var Page = plus.webview.getWebviewById('v_inventory.html');
									mui.fire(Page, 'RefreshEvent');
									return true;
								}
							});
							mui.back();
						}, 'div')
					})
				}
			}, 'div')
		});
		mui('body').on('tap', '.mui-btn', function(e) {
			mui(this).button('loading');
		});
	};
	return {
		run: _.init
	};
})