define(['met'], function(met) {
	var _ = {
		params: null,
		Data: null,
		Type: null,
		pn1: 1, //当前页数
		pn2: 1, //当前页数
		pn3: 1, //当前页数
		PageSize: 20 //一页条数
	};
	_.init = function() {
		mui.init();
		_.PullRefresh();
		mui('.mui-scroll-wrapper').scroll({
			indicators: false //是否显示滚动条
		});
		var item2 = document.getElementById('item2mobile');
		var item3 = document.getElementById('item3mobile');
		document.getElementById('slider').addEventListener('slide', function(e) {
			if(e.detail.slideNumber === 1) {
				_.Type = "SomeTime";
				if(item2.querySelector('.mui-loading')) {
					_.GetData(_.pn2, 0, '#item2mobile .mui-scroll', null)
				}
			} else if(e.detail.slideNumber === 2) {
				_.Type = "Almost";
				if(item3.querySelector('.mui-loading')) {
					_.GetData(_.pn3, 0, '#item3mobile .mui-scroll', null)
				}
			}
		});

		_.Type = "Always";
		_.GetData(_.pn1, 1, '#item1mobile .mui-scroll', null);
	};
	_.PullRefresh = function() {
		var deceleration = mui.os.ios ? 0.003 : 0.0009;
		mui('.mui-scroll-wrapper').scroll({
			bounce: false,
			indicators: false, //是否显示滚动条
			deceleration: deceleration
		});
		mui.ready(function() {
			//循环初始化所有下拉刷新，上拉加载。
			mui.each(document.querySelectorAll('.mui-slider-group .mui-scroll'), function(index, pullRefreshEl) {
				mui(pullRefreshEl).pullToRefresh({
					down: {
						callback: function() {
							var self = this;
							switch(index) {
								case 0:
									_.pn1 = 1;
									_.GetData(_.pn1, 0, '#item1mobile .mui-scroll', self);
									break;
								case 1:
									_.pn2 = 1;
									_.GetData(_.pn2, 0, '#item2mobile .mui-scroll', self);
									break;
								case 2:
									_.pn3 = 1;
									_.GetData(_.pn3, 0, '#item3mobile .mui-scroll', self);
									break;
								default:
									break;
							}
						}
					},
					up: {
						callback: function() {
							var self = this;
							switch(index) {
								case 0:
									_.pn1 = _.pn1 + 1;
									_.GetData(_.pn1, 0, '#item1mobile .mui-scroll', self);
									break;
								case 1:
									_.pn2 = _.pn2 + 1;
									_.GetData(_.pn2, 0, '#item2mobile .mui-scroll', self);
									break;
								case 2:
									_.pn3 = _.pn3 + 1;
									_.GetData(_.pn3, 0, '#item3mobile .mui-scroll', self);
									break;
								default:
									break;
							}
						}
					}
				});
			});
		});
	};
	_.GetData = function(pn, iscount, self, pull) {
		var u = plus.storage.getItem('UserInfo');
		u = JSON.parse(u);
		_.params = {
			URL: 'AppApi/member',
			Data: {
				pn: pn,
				PageSize: _.PageSize,
				tag: _.Type,
				Menus: u.Menus,
				iscount: iscount
			}
		}
		met.ajax(_.params, null, function(data) {
			$(self).find('.mui-loading').remove();
			if(iscount == 1) {
				var html = [];
				html.push('<li class="mui-col-xs-6" data-type="All"><span>{0}</span><p>全部会员</p></li><li class="mui-col-xs-6" data-type="Batch"><span>{1}</span><p>套餐会员</p></li>'.format(data.UserCount.Data.All, data.UserCount.Data.Batch));
				if(data.FollowEmployee == 0) {
					html.push('<li class="mui-col-xs-6" data-type="Focus"><span>{0}</span><p>关注会员</p></li>'.format(data.UserCount.Data.Focus));
				}
				$('.member-view').html(html.join(''));
			}
			if(data.User.Code == 0) {
				mui.alert(data.User.Msg, '温馨提示', '确定', function(e) {
					e.index
				}, 'div')
				return;
			}
		_.event();
			_.Data = data.User.Data;
			_.OutputHtml(pn, self, pull);
		});
	};
	_.OutputHtml = function(pn, self, pull) {
		var html = [],
			d = _.Data;
		for(var i = 0; i < d.length; i++) {
			html.push('<li data-list='+"'"+JSON.stringify(d[i])+"'"+' class="mui-table-view-cell mui-media"><a class="mui-navigate-right"><img class="mui-media-object mui-pull-left" src="{0}"><div class="mui-media-body mic-member-img">{1}'.format(d[i].Pics == '' ? '../img/tx.png' : d[i].Pics, d[i].Phone));
			if(d[i].CustomerRank == 50) {
				html.push('<img src="../img/mem_09.png">');
			} else {
				html.push('<img src="../img/mem_10.png">');
			}
			if(d[i].BatchId > 0) {
				html.push('<img src="../img/mem_11.png">');
			}
			html.push('<p class="mui-ellipsis">{0}{1}</p></div></a></li>'.format(d[i].CarNo == null ? '' : d[i].CarNo, d[i].ZhName == '' ? '' : '<' + d[i].ZhName + '>'));
		}
//		if(d.length==0){
//			html.push('<p class="mic-search-alert">没有数据</p>');
//		}
		if(pn == 1) {
			if(pull != null) {
				pull.endPullDownToRefresh();
			}
			$(self).find('.mui-table-view').html(html.join(''));
		} else {
			if(pull != null) {
				pull.endPullUpToRefresh((d.length < _.PageSize));//true 没有数据
			}
			$(self).find('.mui-table-view').append(html.join(''));
		}
		mui('.mui-slider-group').off('tap');
		mui('.mui-slider-group').on('tap', '.mui-table-view li', function() {
			met.OpenWindow('member_detail.html', null, {
				list: JSON.parse(this.getAttribute('data-list'))
			});
		});
	};
	_.event = function() {
		mui('body').on('tap', '.member-useradd', function() {
			met.OpenWindow(this.getAttribute('href'), null, null);
		});
		mui('body').on('tap', '.member-view li', function() {
			met.OpenWindow('member_info.html', null, {
				Type: this.getAttribute('data-type')
			});
		});
		//搜索
		mui('body').on('tap','.member-search',function(){
		  met.OpenWindow('member_search.html', 'slide-in-bottom',null);
		});
	};
	return {
		run: _.init
	};
})