define(['met', 'mos'], function(met, mos) {
	var _ = {
		params: null,
	};
	_.init = function() {
		mui.init({
			swipeBack: true
		});
		var nativeWebview, imm, InputMethodManager;
		var initNativeObjects = function() {
			if(mui.os.android) {
				var main = plus.android.runtimeMainActivity();
				var Context = plus.android.importClass("android.content.Context");
				InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
				imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
			} else {
				nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
			}
		};
		var showSoftInput = function() {
			var nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
			if(mui.os.android) {
				//强制当前webview获得焦点
				plus.android.importClass(nativeWebview);
				nativeWebview.requestFocus();
				imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
			} else {
				nativeWebview.plusCallMethod({
					"setKeyboardDisplayRequiresUserAction": false
				});
			}
			setTimeout(function() {
				//此处可写具体逻辑设置获取焦点的input
				var inputElem = document.querySelector('input');
				inputElem.focus();
			}, 100);
		};
		mui.plusReady(function() {
			initNativeObjects();
			showSoftInput();
		});
		document.getElementById("SearchForm").addEventListener("keydown", function(e) {
			if(13 == e.keyCode) { //点击了“搜索”  
				document.activeElement.blur(); //隐藏软键盘 
				var Sw = $(".mic-search-input").val();
				if(Sw.length < 2) {
					mui.alert('请至少输入2个字符', '温馨提示', '确定', function(e) {
						showSoftInput();
					}, 'div')
					return false;
				}
				met.ajax({
					URL: 'AppApi/Search',
					Data: {
						Sw: Sw
					}
				}, null, function(data) {
					_.Data = data;
					_.OutputHtml();
				});
			}
		}, false);
	};
	_.OutputHtml = function() {
		var html = [],
			d = _.Data;
		for(var i = 0; i < d.length; i++) {
			html.push('<li data-list=' + "'" + JSON.stringify(d[i]) + "'" + ' class="mui-table-view-cell mui-media"><a class="mui-navigate-right"><img class="mui-media-object mui-pull-left" src="{0}"><div class="mui-media-body mic-member-img">{1}'.format(d[i].Pics == '' ? '../img/tx.png' : d[i].Pics, d[i].Phone));
			if(d[i].CustomerRank == 50) {
				html.push('<img src="../img/mem_09.png">');
			} else {
				html.push('<img src="../img/mem_10.png">');
			}
			if(d[i].BatchId > 0) {
				html.push('<img src="../img/mem_11.png">');
			}
			html.push('<p class="mui-ellipsis">{0}{1}</p></div></a></li>'.format(d[i].CarNo == null ? '' : d[i].CarNo, d[i].ZhName == '' ? '' : '<' + d[i].ZhName + '>'));
		}
		if(d.length == 0) {
			html.push('<p class="mic-search-alert">没有搜到任何数据</p>');
		}
		$('.mui-table-view').html(html.join(''));

		mui('.mui-table-view').off('tap');
		mui('.mui-table-view').on('tap', 'li', function() {
			met.OpenWindow('member_detail.html', null, {
				list: JSON.parse(this.getAttribute('data-list'))
			});
		});
	};
	return {
		run: _.init
	};
})