define(['met', 'mos', 'uploads'], function(met, mos, uploads) {
	var _ = {
		Data: null,
		BatchId: 0,
		BatchPrice: 0,
		Details: null,
		TotalFee: 0
	};
	_.init = function() {
		mui.init({
			swipeBack: true
		});
		_.init.list();
	};
	_.init.list = function() {
		mos.CarNo();
		mos.InfoMatch();
		_.GetViewParams();
		_.event();
	};
	_.GetViewParams = function() {
		window.addEventListener('CardDetailsEvent', function(e) {
			//获得事件参数
			var detail = e.detail;
			_.BatchId = e.detail.BatchId;
			_.BatchPrice = Number(e.detail.Price);
			_.Details = e.detail.Data;
			$('#Batch').val(e.detail.BatchName);
			$('#Price').val(e.detail.Price);
			_.ProductDetailShow();
		});
	};
	_.event = function() {
		//卡券选择
		mui('body').on('tap', '#Batch', function() {
			met.OpenWindow('c_card_class.html', 'slide-in-bottom', null);
		});
		//数据提交
		mui('body').on('tap', '#BtnOrderSubmit', function() {
			//获取数据方法
			mos.InputData(function(data) {
				var Price = $('#Price').val();
				if(isNaN(Number(Price)) || Price == "") {
					mui.alert('请输入正确的卡券价格', '温馨提示', '确定', function(e) {
						e.index
					}, 'div')
					return;
				}
				if(Number(Price) > _.BatchPrice) {
					mui.alert('当前输入的价格大于此卡券规定价格，请重新输入', '温馨提示', '确定', function(e) {
						e.index
					}, 'div')
					return;
				}
				var Details = [];
				for(var m in _.Details) {
					Details.push({
						Id: _.Details[m].Id,
						ProductId: _.Details[m].ProductId,
						Name: _.Details[m].Name,
						Qty: _.Details[m].Qty,
						ServicePrice: _.Details[m].Price
					})
				}
				var PostMethod = function() {
					var params = {
						ZhName: data.ZhName,
						BatchId: _.BatchId,
						TotalFee: Price,
						Phone: data.Phone,
						CarNo: data.CarNo,
						BrandId: data.BrandId,
						SerId: data.SerId,
						SpecId: data.SpecId,
						Details: JSON.stringify(Details)
					};
					met.ajax({
						URL: 'AppApi/UserBatch',
						Data: params
					}, null, function(data) {
						if(data == null) {
							mui.alert('未知错误，请联系IT人员', '温馨提示', '确定', function(e) {
								e.index
							}, 'div')
							return;
						}
						met.OpenWindow('v_payment.html', null, {
							OrderNo: data
						});
					});
				};
				if(_.BatchPrice == Number(Price)) {
					PostMethod();
				} else {
					mui.confirm('当前价格小于此卡券所规定价格，是否继续此操作？', '温馨提示', ['取消', '确认'], function(e) {
						if(e.index == 1) {
							PostMethod();
						}
					}, 'div')
				}
			});
		})
	};

	return {
		run: _.init
	};
})