define(['met', 'mos', 'uploads'], function(met, mos, uploads) {
	var _ = {
		Data: null,
		Details: [],
		TotalFee: 0
	};
	_.init = function() {
		mui.init({
			swipeBack: true
		});
		_.init.list();
	};
	_.init.list = function() {
		mos.CarNo();
		mos.InfoMatch();		
		_.event();
	};
	_.GetProductData = function(List) {
		mos.ProductOperation(List, function(_event) {
			if(_event == 'right') { //更新
				List.Name = $('#ProductName').val();
				List.Fen = $('#Fen').val();
				List.Price = $('#Price').val();
				List.Profit = $('#Profit').val();
				if(List.Name == "") {
					mui.alert('请输入服务项目', '提示', '好的', function(e) {
						mui('.mui-btn').button('reset');
					}, 'div')
					return;
				}
				if(isNaN(Number(List.Price)) || List.Price == "") {
					mui.alert('请检测价格是否输入正确', '提示', '好的', function(e) {
						mui('.mui-btn').button('reset');
					}, 'div')
					return;
				}
				if(isNaN(Number(List.Profit)) || List.Profit == "") {
					mui.alert('请检测毛利是否输入正确', '提示', '好的', function(e) {
						mui('.mui-btn').button('reset');
					}, 'div')
					return;
				}
				if(isNaN(Number(List.Fen)) || List.Fen == "") {
					mui.alert('请检测分数是否输入正确', '提示', '好的', function(e) {
						mui('.mui-btn').button('reset');
					}, 'div')
					return;
				}
				_.Details.splice(List.m, 1, List);
			} else { //删除
				_.Details.splice(List.m, 1);
			}
			$('#ProductOperation').remove();
			_.ProductDetailShow();
		})
	};
	_.ProductDetailShow = function() {
		var shtml = [];
		_.TotalFee = 0;
		shtml.push('<ul class="mic-detail-view">');
		for(var prop in _.Details) {
			_.TotalFee = Number(_.TotalFee) + Number(_.Details[prop].Price);
			shtml.push('<li data-id={4}><div class="mic-detail-left mui-ellipsis-2">项目{0} {1}</div><div class="mic-detail-right"><span>+{2}</span><span>单价：{3}</span></div></li>'.format(Number(prop) + 1, _.Details[prop].Name, _.Details[prop].Fen, _.Details[prop].Price, prop));
		}
		shtml.push('</ul>');
		$('#ProductDetail').html(shtml.join(''));
		$('.mic-btn-total').find('span').html(_.TotalFee);
		mui('.mic-detail-view').off('tap');
		mui('.mic-detail-view').on('tap', 'li', function() {
			var m = this.getAttribute('data-id');
			var List = {
				m: m,
				Id: _.Details[m].Id,
				Name: _.Details[m].Name,
				Price: _.Details[m].Price,
				Profit: _.Details[m].Profit,
				Type: _.Details[m].Type,
				Fen: _.Details[m].Fen,
				Tag: 'Update'
			};
			_.GetProductData(List);
		});

	};
	_.event = function() {
		mui('body').on('tap', '.mui-btn', function(e) {
			mui(this).button('loading');
		});
		//项目服务添加
		mui('body').on('tap', '#ProductAdd', function() {
			var List = {
				Id: 0,
				Name: '',
				Price: '',
				Profit:'',
				Type: '违章',
				Fen: 0,
				Tag: 'Add'
			};
			_.GetProductData(List);
		});
		mui('body').on('tap', '#ProductType', function() {
			document.activeElement.blur();
		});
		//数据提交
		mui('body').on('tap', '#BtnOrderSubmit', function() {
			//获取数据方法
			mos.InputData(function(data) {
				var params = {
					OrderSource: 10,
					BrandId: data.BrandId,
					SerId: data.SerId,
					SpecId: data.SpecId,
					TotalFee: _.TotalFee,
					IdentityNo: data.IdentityNoYes,
					CarEngineNo: data.CarEngineNo,
					Phone: data.Phone,
					CarNo: data.CarNo,
					ZhName: data.ZhName
				};
				if(_.Details.length == 0) {
					mui.alert('请至少选择一个服务项目', '提示', '好的', function(e) {
						e.index
					}, 'div')
					return;
				}
				var Details = [];
				for(var prop in _.Details) {
					Details.push({
						ProductId: _.Details[prop].Id,
						ProductName: _.Details[prop].Name,
						Fen: _.Details[prop].Fen || 0,
						Price: _.Details[prop].Price || 0,
						Profit: _.Details[prop].Profit || 0,
						Cat: _.Details[prop].Type,
					});
				}
				params.Details = JSON.stringify(Details);
				met.ajax({
					URL: 'AppApi/CreateOrder',
					Data: params
				}, null, function(data) {
					mui.confirm('开单成功，是否继续开单？', '友情提示', ['返回', '继续'], function(e) {
						if(e.index == 1) {
							location.reload();
						} else {
							mui.back();
						}
					}, 'div')
				});
			});
		})
	};

	return {
		run: _.init
	};
})