define(['met', 'mos', 'uploads'], function(met, mos, uploads) {
	var _ = {
		Data: null,
		DataMain: null,
		Details: [],
		BatchDetails: [],
		TotalFee: 0
	};
	_.init = function() {
		mui.init({
			swipeBack: true
		});
		met.ajax({
			URL: 'AppApi/GetBatchProductList'
		}, null, function(data) {
			_.DataMain = data;
			_.init.list();
		});
	};
	_.init.list = function() {
		mos.CarNo();
		mos.InfoMatch();
		_.GetViewParams();
		_.event();
	};
	_.GetProductData = function(List) {
		mos.ProductOperation(List, function(_event) {
			if(_event == 'right') { //更新
				List.Qty = $('#Qty').val();
				List.Price = $('#Price').val();
				List.Profit = $('#Profit').val();
				if(isNaN(Number(List.Price)) || List.Price == "") {
					mui.alert('请检测价格是否输入正确', '提示', '好的', function(e) {
						mui('.mui-btn').button('reset');
					}, 'div')
					return;
				}
				if(List.Type == '轮胎' && (isNaN(Number(List.Profit)) || List.Profit == "")) {
					mui.alert('请检测毛利是否输入正确', '提示', '好的', function(e) {
						mui('.mui-btn').button('reset');
					}, 'div')
					return;
				}
				if(isNaN(Number(List.Qty)) || List.Qty == "") {
					mui.alert('请检测数量是否输入正确', '提示', '好的', function(e) {
						mui('.mui-btn').button('reset');
					}, 'div')
					return;
				}
				_.Details.splice(List.m, 1, List);
			} else { //删除
				_.Details.splice(List.m, 1);
			}
			$('#ProductOperation').remove();
			_.ProductDetailShow();
		})
	};
	_.GetProductBatchData = function(List) {
		met.OpenWindow('c_product_batch.html', 'slide-in-bottom', {
			Data: List
		});
		//		mos.ProductBatchOperation(List, function(_event) {
		//			if(_event == 'right') { //更新
		//				List.Price = Number($('#Total').find('span').html());
		//				$('.Qty').each(function(i) {
		//					var Qty = $(this).val();
		//					if(isNaN(Number(Qty)) || Qty == "") {
		//						mui.alert('请检测数量是否输入正确', '提示', '好的', function(e) {
		//							mui('.mui-btn').button('reset');
		//						}, 'div')
		//						return false;
		//					}
		//					List.Ids[i].Qty = Qty;
		//				})
		//
		//				_.BatchDetails.splice(List.m, 1, List);
		//			} else { //删除
		//				_.BatchDetails.splice(List.m, 1);
		//			}
		//			$('#ProductBatchOperation').remove();
		//			_.ProductBatchDetailShow();
		//		})
	};
	_.ProductDetailShow = function() {
		var shtml = [];
		_.TotalFee = 0;
		shtml.push('<ul class="mic-detail-view">');
		for(var prop in _.Details) {
			_.TotalFee = Number(_.TotalFee) + Number(_.Details[prop].Price);
			shtml.push('<li data-id={4}><div class="mic-detail-left">其它{0} {1}</div><div class="mic-detail-right"><span>×{2}</span><span>单价：{3}</span></div></li>'.format(Number(prop) + 1, _.Details[prop].Name, _.Details[prop].Qty, _.Details[prop].Price, prop));
		}
		shtml.push('</ul>');
		$('#ProductDetail').html(shtml.join(''));
		mui('.mic-detail-view').off('tap');
		mui('.mic-detail-view').on('tap', 'li', function() {
			var m = this.getAttribute('data-id');
			var List = {
				m: m,
				Id: _.Details[m].Id,
				Name: _.Details[m].Name,
				Price: _.Details[m].Price,
				Profit: _.Details[m].Profit,
				Type: _.Details[m].Type,
				Qty: _.Details[m].Qty,
				Tag: 'Update'
			};
			_.GetProductData(List);
		});

	};
	_.ProductBatchDetailShow = function() {
		var shtml = [];
		for(var m in _.BatchDetails) {
			shtml.push('<div class="mic-tain-detail" data-id={0}>'.format(m));
			shtml.push('<div class="mic-tain-row mui-ellipsis">套餐{0} {1}</div>'.format(Number(m) + 1, _.BatchDetails[m].Name));
			for(var n in _.BatchDetails[m].Ids) {
				shtml.push('<div class="mic-tain-row"><label class="mui-ellipsis">{0}.{1}</label><span>{2}×{3}</span></div>'.format(Number(n) + 1, _.BatchDetails[m].Ids[n].Name, _.BatchDetails[m].Ids[n].Price, _.BatchDetails[m].Ids[n].Qty));
			}
			shtml.push('<div class="mic-tain-row"><span>总价：{0}</span></div></div>'.format(_.BatchDetails[m].Price.toFixed(2)));
		}
		$('#ProductBatchDetail').html(shtml.join(''));
		mui('#ProductBatchDetail').off('tap');
		mui('#ProductBatchDetail').on('tap', '.mic-tain-detail', function() {
			var m = this.getAttribute('data-id');
			var List = _.BatchDetails[m];
			List.m = m;
			List.Tag = 'Update';

			_.GetProductBatchData(List);
		});

	};
	_.GetViewParams = function() {
		window.addEventListener('CarBrandEvent', function(e) {
			//获得事件参数
			var data = e.detail;
			$('#CarBrand').val(data.BrandName).attr({
				'data-brand': data.BrandId
			}).attr({
				'data-ser': data.SerId
			}).attr({
				'data-spec': data.SpecId
			});
		});
		window.addEventListener('ProductEvent', function(e) {
			//获得事件参数
			if(e.detail.Id == 'Batch') {
				var d = e.detail.Data
				if(d.Tag == 'Update') {
					_.BatchDetails.splice(d.m, 1, d);
				} else if(d.Tag == 'Delete') {
					_.BatchDetails.splice(d.m, 1);
				} else {
					_.BatchDetails.push(d);
				}
				_.ProductBatchDetailShow();
			} else {
				_.Details.push(e.detail.Data);
				_.ProductDetailShow();
			}
		});
	};
	_.event = function() {
		mui('body').on('tap', '.mui-btn', function(e) {
			mui(this).button('loading');
		});
		//品牌选择
		mui('body').on('tap', '#CarBrand', function() {
			met.OpenWindow('c_models.html', 'slide-in-bottom', {
				Url: 'v_order_maintain.html'
			});
		});
		//保养套餐添加
		mui('body').on('tap', '#ProductBatchAdd', function() {
			if(_.Data != null) {
				met.OpenWindow('c_product.html', 'slide-in-bottom', {
					Url: 'v_order_maintain.html',
					Id: 'Batch',
					Data: {m:_.DataMain,d:_.Data}
				});
				return;
			}
			met.ajax({
				URL: 'AppApi/GetProductList'
			}, null, function(data) {
				for(var prop in data) {
					if(prop == '保养') {
						_.Data={'保养':data[prop]};
						break;
					}
				}

				met.OpenWindow('c_product.html', 'slide-in-bottom', {
					Url: 'v_order_maintain.html',
					Id: 'Batch',
					Data:{m:_.DataMain,d:_.Data}
				});
			});
		});
		//项目服务添加
		mui('body').on('tap', '#ProductAdd', function() {
			if(_.Data != null) {
				met.OpenWindow('c_product.html', 'slide-in-bottom', {
					Url: 'v_order_maintain.html',
					Data: _.Data
				});
				return;
			}
			met.ajax({
				URL: 'AppApi/GetProductList'
			}, null, function(data) {
				for(var prop in data) {
					if(prop == '保养') {
						//						_.Data = {
						//							保养: data[prop]
						//						};
						_.DataMain['保养'] = data[prop];
						break;
					}
				}

				met.OpenWindow('c_product.html', 'slide-in-bottom', {
					Url: 'v_order_maintain.html',
					Data: _.Data
				});
			});
		});
		mui('body').on('tap', '#ProductType', function() {
			document.activeElement.blur();
		});
		//数据提交
		mui('body').on('tap', '.mic-btn-submit', function() {
			//获取数据方法
			mos.InputData(function(data) {
				var params = {
					OrderSource: 6,
					CarNo: data.CarNo,
					BrandId: data.BrandId,
					SerId: data.SerId,
					SpecId: data.SpecId,
					TotalFee: _.TotalFee,
					Phone: data.Phone,
					CarMileage: data.CarMileage,
					Displayment: data.Displayment
				};
				var TotalDetails = _.BatchDetails.concat(_.Details);
				if(TotalDetails.length == 0) {
					mui.alert('请至少选择一个保养套餐', '提示', '好的', function(e) {
						e.index
					}, 'div')
					return;
				}
				var Details = [];
				for(var prop in TotalDetails) {
					Details.push({
						ProductId: TotalDetails[prop].Id,
						ProductName: TotalDetails[prop].Name,
						Qty: TotalDetails[prop].Qty || 1,
						Price: TotalDetails[prop].Price || 0,
						Profit: TotalDetails[prop].Profit || 0,
						Cat: TotalDetails[prop].Type,
						Ids: JSON.stringify(TotalDetails[prop].Ids || [])
					});
				}
				params.Details = JSON.stringify(Details);
				met.ajax({
					URL: 'AppApi/CreateOrder',
					Data: params
				}, null, function(data) {
					mui.confirm('开单成功，是否继续开单？', '友情提示', ['返回', '继续'], function(e) {
						if(e.index == 1) {
							location.reload();
						} else {
							mui.back();
						}
					}, 'div')
				});
			});
		})
	};

	return {
		run: _.init
	};
})