define(['met'], function(met) {
	var _ = {
		params: null,
		OrderNo: null,
		Data: null,
	};
	_.init = function() {
		mui.init();
		_.OrderNo = plus.webview.currentWebview().OrderNo;
		_.params = {
			URL: 'AppApi/payment',
			Data: {
				OrderNo: _.OrderNo
			}
		}
		met.ajax(_.params, null, function(data) {
			_.Data = data;
			$('.pay-fee span').html(data.ShouldPay.toFixed(2));
			var NameMs = null;
			if(data.CarNo == "" || data.CarNo == null) {
				NameMs = data.ZhName;
			} else {
				NameMs = data.CarNo;
			}
			$('.pay-name').html(NameMs);
			var CodeHttp = 'http://m.guanjia.cz888.com/payApi/QRCode/{0}/{1}'.format(data.ShouldPay, _.OrderNo)
			$('.pay-code img').attr({
				"src": CodeHttp
			})
			_.event();
		});
	};
	_.event = function() {
		mui('.mui-table-view').on('tap', 'li', function() {
			var u = this.getAttribute('data-url');
			switch(u) {
				case 'cash':
					_.PaymentCash();
					break;
				case 'card':
					mui.alert('刷卡支付暂未完善', '温馨提示', '确定', function(e) {
						e.index
					}, 'div')
					break;
				default:
					break;
			}
		})
	};
	_.PaymentCash = function() {
		var html = [];
		html.push('<div class="mui-backdrop" id="Payment"><div class="pay-nl"><div class="mic-product-close"><span class="mic-match-remove mui-icon mui-icon-closeempty"></span></div>');
		html.push('<div class="mic-input"><div class="mic-input-row"><label>应付金额：</label><span>' + _.Data.ShouldPay.toFixed(2) + '</span></div></div>');
		html.push('<div class="mic-input"><div class="mic-input-row"><label>实付金额：</label><input type="text" value=' + _.Data.ShouldPay.toFixed(2) + ' id="PayAccount" placeholder="请输入实付金额" /><span class="mic-cue mic-icon icon-asterisk"></span></div></div>');
		html.push('<div class="pay-btn">确认付款</div></div></div>');
		$('body').append(html.join(''));
		mui('#Payment').on('tap', '.mic-product-close', function() {
			$('#Payment').remove();
		});
		mui('#Payment').on('tap', '.pay-btn', function() {
			var PayAccount = $("#PayAccount").val();
			if(isNaN(Number(PayAccount)) || PayAccount == "") {
				mui.alert('金额输入错误', '温馨提示', '确定', function(e) {
					e.index
				}, 'div')
				return;
			}
			if(Number(PayAccount) > Number(_.Data.ShouldPay)) {
				mui.alert('您输入的金额大于应付金额' + _.Data.ShouldPay, '温馨提示', '确定', function(e) {
					e.index
				}, 'div')
				return;
			}
			var PaymentPost = function() {
				var params = {
					URL: 'AppApi/pay',
					Data: {
						OrderNo: _.OrderNo,
						ActPay: PayAccount,
						PayWay: "Cash"
					}
				}
				met.ajax(params, null, function(data) {
					mui.later(function() {
						plus.webview.close('v_payment.html');
					}, 500)
					met.OpenWindow('v_payment_bill.html', null, {
						OrderNo: _.OrderNo
					});
				});
			};
			if(Number(PayAccount) < Number(_.Data.ShouldPay)) {
				mui.confirm('请确认支付金额是否为￥' + PayAccount + '？', '温馨提示', ['取消', '确认'], function(e) {
					if(e.index == 1) {
						PaymentPost();
					}
				}, 'div')
			} else {
				PaymentPost();
			}
		})
	};
	return {
		run: _.init
	};
})