define(['met'], function(met) {
	var _ = {
		params: null,
		Data: null,
		AI: null,
		AClick: null
	};
	_.init = function() {
		mui.init({
			swipeBack: true
		});
		_.params = {
			URL: 'AppApi/GetFollowOrder',
			Data: {
				StatusList: "1,5,10"
			}
		}
		met.ajax(_.params, null, function(data) {
			_.Data = data;
			_.OutputHtml();
		});
	};
	_.OutputHtml = function() {
		var html = [],
			d = _.Data;
		for(var i = 0; i < d.length; i++) {
			html.push('<div class="mui-card"><div class="mui-card-header mui-card-media mic-card-header"><div class="mui-media-body">{0}<p>{1}</p></div>'.format(d[i].OrderSourceName, d[i].BillDate));
			//取消
			if(d[i].IsPaid != 1 && d[i].Status != 10) {
				html.push('<span data-id="{0}" class="mui-icon mui-icon-closeempty TDelete"></span>'.format(d[i].OrderNo));
			}
			html.push('</div><div class="mui-card-content">');
			if(d[i].OrderSource != 1) {
				html.push('<div class="mic-card-content-innter">施工状态：<span>{0}</span></div>'.format(d[i].StatusName));
			}
			if(d[i].CarNo != '' && d[i].CarNo != null && d[i].CarNo.length > 5) {
				html.push('<div class="mic-card-content-innter">车牌号码：{0}</div>'.format(d[i].CarNo));
			}
			if(d[i].IdentityNo != '' && d[i].IdentityNo != null) {
				html.push('<div class="mic-card-content-innter">车架号码：{0}</div>'.format(d[i].IdentityNo));
			}
			if(d[i].Phone != '' && d[i].Phone != null) {
				html.push('<div class="mic-card-content-innter">手机号码：{0}</div>'.format(d[i].Phone));
			}
			if(d[i].IsPaid > 0 && d[i].AccountFee > 0) {
				html.push('<div class="mic-card-content-innter">余额抵扣：<span>{0}</span></div>'.format(d[i].AccountFee.toFixed(2)));
			}
			if(d[i].IsPaid == 0 && d[i].CouponFee > 0) {
				html.push('<div class="mic-card-content-innter">卡卷抵扣：<span>{0}</span></div>'.format(d[i].CouponFee.toFixed(2)));
			}
			if(d[i].OrderSource != 1 && d[i].BatchId > 0) {
				html.push('<div class="mic-card-content-innter">套餐抵扣：<span>{0}</span></div>'.format(d[i].BatchName));
			}
			if(d[i].IsPaid == 0 && d[i].ShouldPay > 0) {
				html.push('<div class="mic-card-content-innter">应付金额：<span>{0}</span></div>'.format(d[i].ShouldPay.toFixed(2)));
			}
			if(d[i].IsPaid == 0 && d[i].ActPay > 0) {
				html.push('<div class="mic-card-content-innter">支付金额：<span>{0}</span></div>'.format(d[i].ActPay.toFixed(2)));
			}
			html.push('<div class="mic-card-content-innter">支付状态：<span>{0}</span></div>'.format(d[i].IsPaid == 1 ? '已支付' : '未支付'));
			html.push('<div class="mic-card-content-innter">钥匙扣：{0}</div>'.format(d[i].NickNo));
			//			
			html.push('<ul class="mic-detail-view mic-card-view"><li class="mic-card-product"><label>服务项目</label>');
			//追加项目
			if(d[i].Status == 5 && d[i].IsPaid != 1 && d[i].OrderSource == 10) {
				html.push('<span data-m=' + i + ' class="mui-icon mui-icon-plus TAdd"></span>');
			}
			html.push('</li>');
			var t = d[i].Details;
			for(var m = 0; m < t.length; m++) {
				html.push('<li><div class="mic-detail-left">项目{0} {1}</div><div class="mic-detail-right"><span>×{2}</span><span>单价：{3}</span></div></li>'.format(Number(m) + 1, t[m].ProductName, t[m].Qty, t[m].ServicePrice));
			}
			html.push('</ul></div><div class="mui-card-footer mic-card-footer">');
			//付款、发账单
			if(d[i].IsPaid != 1) {
				html.push('<button data-m=' + i + ' type="button" class="mui-btn mui-btn-card TPayment" data-loading-text="请稍候" data-loading-icon-position="left">付款</button>');
				html.push('<button data-m=' + i + ' type="button" class="mui-btn mui-btn-card SendBill" data-loading-text="请稍候" data-loading-icon-position="left">发账单</button>');
			}
			//申请采购
			if(d[i].CanApply > 0) {
				html.push('<button data-m=' + i + ' type="button" class="mui-btn mui-btn-card TPurchasing" data-loading-text="请稍候" data-loading-icon-position="left">申请采购</button>');
			}
			//完成
			if(d[i].Status == 5) {
				html.push('<button data-m=' + i + ' type="button" class="mui-btn mui-btn-card TFinish" data-loading-text="请稍候" data-loading-icon-position="left">完成</button>');
			}
			html.push('</div></div>')
		}
		$('.mui-content').html(html.join(''));
		_.event();
	};
	_.event = function() {
		//取消订单
		mui('body').on('tap', '.TDelete', function() {
			var _this = this;
			mui.confirm('是否确认取消此订单?', '温馨提示', ['取消', '确认'], function(e) {
				if(e.index == 1) {
					var OrderNo = _this.getAttribute('data-id');
					met.ajax({
						URL: 'AppApi/cancel',
						Data: {
							OrderNo: OrderNo
						}
					}, null, function(data) {
						$(_this).closest('.mui-card').hide(500);
					});
				} else {
					mui('.mui-btn').button('reset');
				}
			}, 'div')
		});
		//追加项目
		mui('body').on('tap', '.TAdd', function() {
			var m = this.getAttribute('data-m');
			_.AI = _.Data[m];
			_.AClick = this;
			met.ajax({
				URL: 'AppApi/GetProductList'
			}, null, function(data) {
				met.OpenWindow('c_product.html', 'slide-in-bottom', {
					Url: 'v_todo.html',
					Data: data
				});
			});
		});
		window.addEventListener('ProductEvent', function(e) {
			//获得事件参数
			var detail = e.detail.Data;
			var params = {
				OrderNo: _.AI.OrderNo,
				ProductId: detail.Id,
				ProductName: detail.Name,
				Qty: detail.Qty,
				Price: detail.Price,
				Profit: detail.Profit || 0,
				Cat: detail.Type
			};
			mui.confirm('是否确认追加服务项目:' + detail.Name, '温馨提示', ['取消', '确认'], function(e) {
				if(e.index == 1) {
					met.ajax({
						URL: 'AppApi/AddItem',
						Data: params
					}, null, function(data) {
						$(_.AClick).closest('.mic-card-view').append('<li><div class="mic-detail-left">项目{0} {1}</div><div class="mic-detail-right"><span>×{2}</span><span>单价：{3}</span></div></li>'.format(_.AI.Details.length + 1, detail.Name, detail.Qty, detail.Price));
						_.init();
					});
				}
			}, 'div')
		});
		//付款
		mui('body').on('tap', '.TPayment', function() {
			mui.later(function() {
				mui('.mui-btn').button('reset');
			}, 500);
			var m = this.getAttribute('data-m');
			met.OpenWindow('v_payment.html', null, {
				OrderNo: _.Data[m].OrderNo
			});
		});
		//发账单
		mui('body').on('tap', '.SendBill', function() {
			var _this = this;
			mui.confirm('是否确认发送此订单信息给车主?', '温馨提示', ['取消', '确认'], function(e) {
				if(e.index == 1) {
					var m = _this.getAttribute('data-m');
					met.ajax({
						URL: 'AppApi/NotifySendNoPay',
						Data: {
							OrderNo: _.Data[m].OrderNo
						}
					}, null, function(data) {
						mui('.mui-btn').button('reset');
						mui.alert('账单信息发送成功', '温馨提示', '好的', function(e) {
							e.index
						}, 'div')
					});
				} else {
					mui('.mui-btn').button('reset');
				}
			}, 'div')
		});
		//申请采购
		mui('body').on('tap', '.TPurchasing', function() {
			mui.later(function() {
				mui('.mui-btn').button('reset');
			}, 500);
			
			var m = this.getAttribute('data-m');
			met.OpenWindow('v_purchasing.html', null, {
				OrderNo: _.Data[m].OrderNo
			})
		});
		//完成订单
		mui('body').on('tap', '.TFinish', function() {
			var _this = this;
			mui.confirm('是否确认完成此订单', '温馨提示', ['取消', '确认'], function(e) {
				if(e.index == 1) {
					var m = _this.getAttribute('data-m');
					var Status = _.Data[m].IsPaid == 1 ? 90 : 10;
					met.ajax({
						URL: 'AppApi/finish',
						Data: {
							OrderNo: _.Data[m].OrderNo
						}
					}, null, function(data) {
						if(Status == 90) {
							$(_this).closest('.mui-card').hide(500);
						} else { //初始化
							_.init();
						}
					});
				} else {
					mui('.mui-btn').button('reset');
				}
			}, 'div')
		});
		mui('body').on('tap', '.mui-btn', function(e) {
			mui(this).button('loading');
			//			setTimeout(function() {
			//				mui(this).button('reset');
			//			}.bind(this), 2000);
		});
		mui('body').on('tap', '#refresh', function() {
			mui('body').off('tap');
			_.init();
		})
	};
	return {
		run: _.init
	};
})