define(['met'], function(met) {
	var _ = {
		Data: null
	};
	_.init = function() {
		mui.init({
			swipeBack: true
		});
		_.Data = plus.webview.currentWebview();
		switch(_.Data.Type) {
			case 'ZhName':
				$('.mui-title').html('姓名');
				$('#ZhName').val(_.Data.Value);
				$('.mui-input-row').show();
				_.Keyboard();
				break;
			case 'Sex':
				$('.mui-title').html('性别');
				$('.mic-bar-btn').hide();
				if(_.Data.Value == '男') {
					$('#Sex li').eq(0).addClass('mui-selected');
				} else {
					$('#Sex li').eq(1).addClass('mui-selected');
				}
				$('#Sex').show();
				break;
			case 'BirthDay':
				$('.mui-title').html('生日');
				$('.mic-bar-btn').removeAttr('disabled');
				$('#BirthDay').show().html(_.Data.Value);
				break;
			case 'Phone':
				$('.mui-title').html('手机号');
				$('.mic-bar-btn').hide();
				$('#Phone').show().html('暂不提供手机号码更换');
				break;
			case 'Address':
				$('.mui-title').html('地区');
				$('.mic-bar-btn').removeAttr('disabled');
				$('#Address').show().html(_.Data.Value);
				break;
			default:
				break;
		}

		_.event();
	};
	_.Keyboard = function() {
		var nativeWebview, imm, InputMethodManager;
		var initNativeObjects = function() {
			if(mui.os.android) {
				var main = plus.android.runtimeMainActivity();
				var Context = plus.android.importClass("android.content.Context");
				InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
				imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
			} else {
				nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
			}
		};
		var showSoftInput = function() {
			var nativeWebview = plus.webview.currentWebview().nativeInstanceObject();
			if(mui.os.android) {
				//强制当前webview获得焦点
				plus.android.importClass(nativeWebview);
				nativeWebview.requestFocus();
				imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
			} else {
				nativeWebview.plusCallMethod({
					"setKeyboardDisplayRequiresUserAction": false
				});
			}
			setTimeout(function() {
				//此处可写具体逻辑设置获取焦点的input
				var inputElem = document.querySelector('input');
				inputElem.focus();
			}, 100);
		};
		mui.plusReady(function() {
			initNativeObjects();
			showSoftInput();
		});
	};
	_.event = function() {
		$('#ZhName').bind('input propertychange', function() {
			var ZhName = $('#ZhName').val();
			if(ZhName == "") {
				$('.mic-bar-btn').attr({
					'disabled': 'disabled'
				});
				return;
			}
			if(ZhName != _.Data.Value) {
				$('.mic-bar-btn').removeAttr('disabled');
			} else {
				$('.mic-bar-btn').attr({
					'disabled': 'disabled'
				});
			}
		});
		document.querySelector('#Sex').addEventListener('selected', function(e) {
			var Sex=$.trim(e.detail.el.innerText)== '男' ? 1 : 2;
			var d = {
				Type: _.Data.Type,
				Value: Sex 
			}
			met.ajax({
				URL: 'AppApi/UpdateInfo',
				Data: d
			}, null, function(data) {
				mui.init({
					beforeback: function() {
						var Page = plus.webview.getWebviewById('user.html');
						mui.fire(Page, 'UserEvent', d);
						return true;
					}
				});
				mui.back();
			})
		});
		document.getElementById("BirthDay").addEventListener('tap', function() {
			var dDate = new Date();
			plus.nativeUI.pickDate(function(e) {
				var d = e.date;
				$('#BirthDay').html(d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate());
			}, function(e) {}, {
				title: "请选择日期",
				date: dDate
			});
		});
		mui('body').on('tap', '.mic-bar-btn', function() {
			var d = null;
			switch(_.Data.Type) {
				case 'ZhName':
					d = {
						Type: _.Data.Type,
						Value: $('#ZhName').val()
					}
					break;
				case 'BirthDay':
					d = {
						Type: _.Data.Type,
						Value: $('#BirthDay').html()
					}
					break;
				case 'Address':
					d = {
						Type: _.Data.Type,
						Value: $('#Address').html()
					}
					break;
				default:
					break;
			}

			met.ajax({
				URL: 'AppApi/UpdateInfo',
				Data: d
			}, null, function(data) {
				mui.init({
					beforeback: function() {
						var Page = plus.webview.getWebviewById('user.html');
						mui.fire(Page, 'UserEvent', d);
						return true;
					}
				});
				mui.back();
			})
		})
	};
	return {
		run: _.init
	};
})