define(['met', 'mos', 'uploads'], function(met, mos, uploads) {
	var _ = {
		ProductId: 0,
		ProductName: null,
		Price: 0
	};
	_.init = function() {
		mui.init({
			swipeBack: true
		});
		_.params = {
			URL: 'AppApi/WashList'
		}
		met.ajax(_.params, null, function(data) {
			if(data.length == 0) {
				mui.alert('请到后台添加洗车项目类别', '错误警告', '确定', function(e) {
					e.index
				}, 'div')
				return;
			}
			var List = [];
			for(var prop in data) {
				var detail = [];
				var RelaInfo = data[prop].RelaInfo.split(',');
				for(var p in RelaInfo) {
					var m = RelaInfo[p].split('-');
					detail.push({
						id: m[0],
						price: m[1],
						text: m[3] + "￥" + m[1] + ""
					});
				}
				detail.push({
					id: 0,
					price: 0,
					text: '自定义价'
				});
				List.push({
					id: data[prop].Id,
					price: data[prop].Price,
					text: data[prop].NameAd,
					children: detail
				});
			}
			var userPicker = new mui.PopPicker({
				layer: 2
			});
			userPicker.setData(List);

			mui('body').on('tap', '#ProductType', function() {
				userPicker.show(function(items) {
					$('#ProductType').val(items[0].text + "-" + items[1].text);
					_.ProductId = items[0].id;
					_.ProductName = items[0].text;
					_.Price = items[1].price;
					_.PriceType = items[1].text;
					if(items[1].id == 0) {
						$('#ZPriceSelect').show();
					} else {
						$('#ZPriceSelect').hide();
					}
				});
			});
			_.data = data;
			_.init.list();
		});
	};
	_.init.list = function() {
		mos.CarNo();
		mos.InfoMatch(_.data);
		uploads.Init();
		_.event();
	};
	_.event = function() {
		window.addEventListener('CarBrandEvent', function(e) {
			//获得事件参数
			var data = e.detail;
			$('#CarBrand').val(data.BrandName).attr({
				'data-brand': data.BrandId
			}).attr({
				'data-ser': data.SerId
			}).attr({
				'data-spec': data.SpecId
			});
		});
		//品牌选择
		mui('body').on('tap', '#CarBrand', function() {
			met.OpenWindow('c_models.html', 'slide-in-bottom', {
				Url: 'v_wash.html'
//				MedelsCheck:true
			});
		});
		mui('body').on('tap', '#ProductType', function() {
			document.activeElement.blur();
		});
		//数据提交
		mui('body').on('tap', '.mic-btn-submit', function() {
			//获取数据方法
			mos.InputData(function(data) {
				var price = _.Price;
				if(_.PriceType == '自定义价') {
					price = $('#ZPrice').val();
					if(price == "") {
						box.prompt('请输入自定义价格');
						return;
					}
				}
				var params = {
					OrderSource: 2,
					BrandId: data.BrandId,
					SerId: data.SerId,
					SpecId: data.SpecId,
					TotalFee: price,
					Phone: data.Phone,
					NickNo: data.NickNo,
					Remark: data.Remark
				};
				params.Details = JSON.stringify([{
					Id: _.ProductId,
					ProductId: _.ProductId,
					ProductName: _.ProductName,
					Qty: 1,
					Price: price,
					Profit: price,
					Cat: "洗车"
				}]);
				if(data.CarNoType == 1) {
					params.IdentityNo = data.IdentityNoNot;
				} else {
					params.CarNo = data.CarNo;
					params.ZhName = data.ZhName;
					params.CarMileage = data.CarMileage;
				}
				//带图片上传调用接口
				uploads.UploadsEvent(params, 'AppApi/UploadCreateOrder', function(data) {
					if(data.Code == 0) {
						mui.alert(data.Msg, '友情提示', '确认', function(e) {
							e.index
						}, 'div')
						return;
					}
					mui.confirm('开单成功，是否继续开单？','友情提示',['返回','继续'],function (e) {
						if(e.index==1){
							location.reload();
						}else{
							mui.back();
						}
					},'div')
				});
			});
		})
	};

	return {
		run: _.init
	};
})